package com.vdr.plugins.vodcatcher.tvtoal;

import java.io.*;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import com.sun.syndication.feed.synd.*;
import com.sun.syndication.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Date;
import com.vdr.plugins.vodcatcher.utils.*;



public class TVTotalparser {
	
	private String rssfeeds = "";
	
	private SyndEntry getEntry(String link){

    	SyndEntry entry = new SyndEntryImpl();
    	
    	NCRDecoder decoder = new NCRDecoder();
    	
        entry.setLink("http://tvtotal.prosieben.de" + link);
    	
		try {
			
			//Öffne link
			URL url = new URL("http://tvtotal.prosieben.de" + link);
			URLConnection con = url.openConnection();
			
			BufferedReader bi = new BufferedReader(new InputStreamReader(con.getInputStream()));
		    String line;

		    while ((line = bi.readLine()) != null)
		    {
		    	if (line.matches(".*TV total - Videoplayer - .*")) {
		    		entry.setTitle(line.split("Videoplayer - ")[1].split("<")[0]);
		    		
		    	} else if (line.matches(".*dataClipDescription.*")) {
	                SyndContent description = new SyndContentImpl();
		            description.setType("text/plain");
		            description.setValue(line.replace("+", " ").split("\"")[3]);
		            entry.setDescription(description);

		    	} else if (line.matches(".*videoUrl.*")) {
		    		SyndEnclosureImpl enc = new SyndEnclosureImpl();
	            	enc.setUrl(line.replace("%3A", ":").replace("%2F", "/").split("\"")[3]);
	            	enc.setType("video/wmv");
					List enclist = entry.getEnclosures();
			    	enclist.add(enc);
			    	entry.setEnclosures(enclist);
		    	}
		    }
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}
		
		return entry;
		
	}
	
	public String getFeedEntries(){
		return rssfeeds;

	}
	

	public TVTotalparser (String url_prefix) {
		
		try {
			
			String []days = new String[4];
			days[0] = "mo";
			days[1] = "di";
			days[2] = "mi";
			days[3] = "do";
			
            SyndFeed feed = new SyndFeedImpl();
            feed.setFeedType("rss_2.0");
            feed.setTitle("TVTotal Feed");
            feed.setLink("www.tvtotal.tv");
            feed.setDescription("Current TVTotal entries");
            List entries = new ArrayList();

            for (int i=0 ; i < 4; i++){
				//Öffne link
				URL url = new URL("http://tvtotal.prosieben.de/show/letzte_sendung/" + days[i] + "/");
				URLConnection con = url.openConnection();
				BufferedReader bi = new BufferedReader(new InputStreamReader(con.getInputStream()));
			    String line;
		    	String last = "";
			    
	    		Date date = new Date();

	            
	
			    while ((line = bi.readLine()) != null)
			    {
	
	
			    	if (line.matches(".*videoPopUpHigher.*")) {
			    		
			    		if ( ! last.equals(line.split("\'")[1]) ){
			    			last = line.split("\'")[1];
					    	SyndEntry entry = getEntry(line.split("\'")[1]);
					    	entry.setPublishedDate(date);
			                entries.add(entry);
			    		}
			    	} else if (line.matches(".*TV total -.*")) {
			    		String datestring = line.split("- ")[1].split("<")[0];
			    		int day = Integer.parseInt(datestring.split("\\.")[0]);
			    		int month = Integer.parseInt(datestring.split("\\.")[1]) -1; //TODO: wtf ?
			    		int year = Integer.parseInt(datestring.split("\\.")[2]) - 1900; //TODO: wtf ?
			    		date.setYear(year);
			    		date.setMonth(month);
			    		date.setDate(day);
			    		feed.setPublishedDate(date);		    		
			    	}
		    	}

			}
		    feed.setEntries(entries);
        	//den Feed in datei schreiben
            Writer writer = new FileWriter(feed.getTitle().replace(" ", "_") + ".xml");
            SyndFeedOutput output = new SyndFeedOutput();
            output.output(feed,writer);
            writer.close();
            rssfeeds += "FEED_URL=" + url_prefix + "/" + feed.getTitle().replace(" ", "_") + ".xml\n";
			
		} catch (Exception e) {
			System.err.println(e.getMessage());
		}
		
	}
	
}
