package com.vdr.plugins.vodcatcher.zdfmediathek;

import java.net.*;
import java.util.zip.GZIPInputStream;
import java.io.*;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.input.SAXBuilder;

public class WMVLinkgetter {
	
	private String GetASXContend (String asxfile){
		
		String wmvlink = "" ; 
		
		try {
			
			URL url = new URL(asxfile);
			URLConnection con = url.openConnection();
			
			Document doc = new SAXBuilder().build(con.getInputStream());
			
			//Get Root
			Element rootelement = doc.getRootElement();
			
			//Descend to link ref
			wmvlink = rootelement.getChild("Entry").getChild("Ref").getAttributeValue("href");
            
		} catch (MalformedURLException e) {}
		catch (Exception e){
			System.err.println("ERROR: " + e.getMessage());
		} 
		return wmvlink;

	}
	
	public String GetWMVLink(String link){
		
		String wmvlink = "";
		
		try {
			
			URL url = new URL(link + "?&bw=dsl2000&pp=wmp&view=navJson");
			URLConnection con = url.openConnection();
			con.addRequestProperty("Accept-Encoding", "gzip");
			
			//Die Respone ist gzipped
			GZIPInputStream gzi = new GZIPInputStream(con.getInputStream());
			
			BufferedReader in = new BufferedReader(new InputStreamReader(gzi));
			String line ;

            while ((line = in.readLine()) != null) {
            	
            	if ( line.matches(".*assetUrl.*")) {
            		wmvlink = GetASXContend(line.split("\042")[3]);
            	}
            	
            }
            
		} catch (Exception e){
			System.err.println("ERROR: " + e.getMessage());
		}
		
		return wmvlink;
			
	}

}
